package ProjectElectricLocomotive.src.CollectionGenericObjects;

import ProjectElectricLocomotive.src.Drawnings.DrawingLocomotive;

import javax.swing.*;
import java.awt.image.BufferedImage;
import java.awt.*;
import java.util.Optional;
import java.util.Random;

public abstract class AbstractCompany
{
    protected final int _placeSizeWidth = 100;

    protected final int _placeSizeHeight = 65;

    protected int _pictureWidth;

    protected int _pictureHeight;

    protected ICollectionGenericObjects<DrawingLocomotive> _collection = null;

    private int getMaxCount() {
        return _pictureWidth * _pictureHeight / (_placeSizeWidth * _placeSizeHeight);
    }

    public AbstractCompany(int picWidth, int picHeight, ICollectionGenericObjects<DrawingLocomotive> collection)
    {
        _pictureWidth = picWidth;
        _pictureHeight = picHeight;
        _collection = collection;
        _collection.setMaxCount(getMaxCount());
    }

    public int add(DrawingLocomotive ship) {
        if (_collection == null) {
            return -1;
        }
        return _collection.insert(ship);
    }

    public DrawingLocomotive remove(AbstractCompany company, int position) {
        if(company._collection == null) return null;
        return company._collection.remove(position);
    }


    public DrawingLocomotive GetRandomObjects()
    {
        if(_collection == null) return null;
        Random rnd = new Random();
        int maxCount = getMaxCount();
        return _collection.get(rnd.nextInt(maxCount));
    }
    public BufferedImage show(JLabel pictureBox) {
        BufferedImage bitmap = new BufferedImage(pictureBox.getWidth(), pictureBox.getHeight(), BufferedImage.TYPE_INT_ARGB);
        Graphics2D graphics = bitmap.createGraphics();
        DrawBackground(graphics);
        SetObjectsPosition();
        for (int i = 0; i < (_collection != null ? _collection.getCount() : 0); ++i) {
            if(_collection == null || _collection.get(i) == null) continue;
            DrawingLocomotive obj = _collection.get(i);
            obj.DrawTransport(graphics);
        }
        graphics.dispose();
        return bitmap;
    }


    protected abstract void DrawBackground(Graphics graphics);

    protected abstract void SetObjectsPosition();
}
