package ProjectElectricLocomotive.src.CollectionGenericObjects;

import java.util.ArrayList;
import java.util.List;

public class ListGenericObjects<T> implements ICollectionGenericObjects<T> {
    private final List<T> collection;

    private int maxCount;

    public int getCount() {
        return collection.size();
    }

    public void setMaxCount(int value) {
        if (value > 0) {
            maxCount = value;
        }
    }

    public ListGenericObjects() {
        collection = new ArrayList<>();
    }

    public T get(int position) {
        if (position < 0 || position >= collection.size()) {
            return null;
        }
        return collection.get(position);
    }

    public int insert(T obj) {
        return insert(obj, collection.size());
    }

    public int insert(T obj, int position) {
        if (maxCount == collection.size() || position < 0 || position > collection.size()) {
            return -1;
        }
        collection.add(position, obj);
        return collection.size();
    }

    public T remove(int position) {
        if (position < 0 || position >= collection.size()) {
            return null;
        }
        return collection.remove(position);
    }
}
