package ProjectElectricLocomotive.src.CollectionGenericObjects;

import java.util.Optional;
import java.util.Arrays;

public class MassiveGenericObjects<T> implements ICollectionGenericObjects<T>
{
    private T[] _collection;

    @Override
    public int getCount(){
        return _collection.length;
    }

    @Override
    public void setMaxCount(int value) {
        if (value > 0) {
            if (_collection.length > 0) {
                if (value > _collection.length) {
                    T[] newArray = Arrays.copyOf(_collection, value);
                    _collection = newArray;
                } else if (value < _collection.length) {
                    T[] newArray = Arrays.copyOf(_collection, value);
                    _collection = newArray;
                }
            } else {
                _collection = (T[]) new Object[value];
            }
        }
    }

    public MassiveGenericObjects() {
        _collection = (T[]) new Object[0];
    }
    @Override
    public int insert(T obj) {
        return insert(obj, 0);
    }

    @Override
    public int insert(T obj, int position) {
        for(int i = position; i < getCount(); i++)
        {
            if (_collection[i] == null)
            {
                _collection[i] = obj;
                return i;
            }
        }
        for(int i = position - 1; i >= 0; --i)
        {
            if (_collection[i] == null)
            {
                _collection[i] = obj;
                return i;
            }
        }
        return -1;
    }

    @Override
    public T remove(int position) {
        if (position < 0 || position >= getCount()) return null;
        if (_collection[position] != null)
        {
            T obj = _collection[position];
            _collection[position] = null;
            return obj;

        }
        return null;
    }

    @Override
    public T get(int position) {
        if(position >= 0 && position < getCount())
        {
            return _collection[position];
        }
        else
        {
            return null;
        }
    }
}