package ProjectElectricLocomotive.src.CollectionGenericObjects;

import ProjectElectricLocomotive.src.Drawnings.*;
import ProjectElectricLocomotive.src.Entities.EntityElectricLocomotive;
import ProjectElectricLocomotive.src.Entities.EntityLocomotive;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class SpecialGenerateLocomotive <T extends EntityLocomotive, U extends IDrawingOrnament>
{
    public List<T> entityArray = new ArrayList<T>();
    public List<U> wheelsArray = new ArrayList<U>();

    public void add(T element) {
        entityArray.add(element);
    }

    public void add(U element) {
        wheelsArray.add(element);
    }

    public String getEn(int ind) {
        if(entityArray.get(ind) instanceof EntityElectricLocomotive) {
            EntityElectricLocomotive entity = (EntityElectricLocomotive)entityArray.get(ind);
            return "EntityElectricLocomotive{" +
                    "speed=" + entity.GetSpeed() +
                    ", weight=" + entity.GetWeight() +
                    ", bodyColor=" + entity.GetBodyColor() +
                    ", AdditionalColor=" + entity.GetAdditionalColor() +
                    ", Horns=" + entity.GetElectricHorns() +
                    ", BatteryPlacement=" + entity.GetBatteryPlacement() +
                    ", step=" + entity.GetStep() +
                    '}';
        }
        else{
            return "EntityLocomotive{" +
                    "speed=" + entityArray.get(ind).GetSpeed() +
                    ", weight=" + entityArray.get(ind).GetWeight() +
                    ", bodyColor=" + entityArray.get(ind).GetBodyColor() +
                    ", step=" + entityArray.get(ind).GetStep() +
                    '}';
        }
    }
    public String getDec(int ind)
    {
        if(wheelsArray.get(ind) instanceof DrawingOrnamentWheels)
        {
            return "DrawingOrnamentWheels - " + ((DrawingOrnamentWheels) wheelsArray.get(ind))._wheels.GetCountWheels();
        }
        else if(wheelsArray.get(ind) instanceof DrawingWheels)
        {
            return "DrawingWheels - " + ((DrawingWheels) wheelsArray.get(ind))._wheels.GetCountWheels();
        }
        else
        {
            return "DrawingSecondOrnamentWheels - " + ((DrawningSecondOrnamentWheels) wheelsArray.get(ind))._wheels.GetCountWheels();
        }
    }
    public DrawingLocomotive createDrawingObject() {
        Random rnd = new Random();
        T _objectFromArray = entityArray.get(rnd.nextInt(entityArray.size()));
        DrawingLocomotive _locomotiveCreated;
        if (_objectFromArray instanceof EntityElectricLocomotive) {
            DrawingElectricLocomotive _electricLocomotive = new DrawingElectricLocomotive(_objectFromArray.GetSpeed(), _objectFromArray.GetWeight(), _objectFromArray.GetBodyColor(), ((EntityElectricLocomotive) _objectFromArray).GetAdditionalColor(), ((EntityElectricLocomotive) _objectFromArray).GetElectricHorns(), ((EntityElectricLocomotive) _objectFromArray).GetBatteryPlacement());
            _electricLocomotive._ornament = wheelsArray.get(rnd.nextInt(wheelsArray.size()));
            _locomotiveCreated = _electricLocomotive;
        } else {
            _locomotiveCreated = new DrawingLocomotive(_objectFromArray.GetSpeed(), _objectFromArray.GetWeight(), _objectFromArray.GetBodyColor());
        }
        return _locomotiveCreated;
    }


}
