package ProjectElectricLocomotive.src.Forms;


import ProjectElectricLocomotive.src.DirectionType;
import ProjectElectricLocomotive.src.Drawnings.DrawingLocomotive;
import ProjectElectricLocomotive.src.MovementStrategy.*;

import javax.swing.*;
import java.awt.*;

public class DrawingField  extends JPanel {
    private final FormElectricLocomotive field;
    DrawingLocomotive _drawingLocomotive;
    private AbstractStrategy _strategy = null;
    public DrawingField(FormElectricLocomotive field) {
        this.field = field;
    }

    public void setLocomotive(DrawingLocomotive locomotive) {
        _drawingLocomotive = locomotive;
        _drawingLocomotive.SetPictureSize(getWidth(),getHeight());
        field.comboBoxStrategy.setEnabled(true);
        _strategy = null;
    }

    @Override
    protected void paintComponent(Graphics g)
    {
        if (_drawingLocomotive == null) return;
        _drawingLocomotive.DrawTransport(g);
    }
    public void UpButtonAction()
    {
        if (_drawingLocomotive == null) return;
        _drawingLocomotive.MoveTransport(DirectionType.Up);
    }
    public void DownButtonAction()
    {
        if (_drawingLocomotive == null) return;
        _drawingLocomotive.MoveTransport(DirectionType.Down);
    }
    public void RightButtonAction()
    {
        if (_drawingLocomotive == null) return;
        _drawingLocomotive.MoveTransport(DirectionType.Right);
    }
    public void LeftButtonAction()
    {
        if (_drawingLocomotive == null) return;
        _drawingLocomotive.MoveTransport(DirectionType.Left);
    }

    public void ButtonStrategyStepAction()
    {
        if(_drawingLocomotive == null) return;
        if (field.comboBoxStrategy.isEnabled())
        {
            int selectedIndex = field.comboBoxStrategy.getSelectedIndex();
            switch (selectedIndex) {
                case 0:
                    _strategy = new MoveToCenter();
                    break;
                case 1:
                    _strategy = new MoveToBorder();
                    break;
                default:
                    _strategy = null;
            }
            if(_strategy == null) return;
            _strategy.SetData(new MoveableLocomotive(_drawingLocomotive), getWidth(), getHeight());
        }
        if (_strategy == null) return;
        field.comboBoxStrategy.setEnabled(false);
        _strategy.MakeStep();

        if(_strategy.getStatus() == StrategyStatus.Finish)
        {
            field.comboBoxStrategy.setEnabled(true);
            _strategy = null;
        }
    }

    public void ResizeField(){
        if (_drawingLocomotive == null) return;
        _drawingLocomotive.SetPictureSize(getWidth(),getHeight());
    }
}
