package ProjectElectricLocomotive.src.Forms;

import ProjectElectricLocomotive.src.CollectionGenericObjects.*;
import ProjectElectricLocomotive.src.Drawnings.DrawingElectricLocomotive;
import ProjectElectricLocomotive.src.Drawnings.DrawingLocomotive;

import java.util.LinkedList;

import javax.swing.*;
import java.awt.*;
import java.util.Random;

public class DrawingLocomotiveCollection extends JPanel
{
    private final FormLocomotiveCollection field;
    private AbstractCompany _company = null;

    private LinkedList<DrawingLocomotive> delLocomotive;
    private final StorageCollection<DrawingLocomotive> storageCollection;

    public DrawingLocomotiveCollection(FormLocomotiveCollection field) {
        this.field = field;

        storageCollection = new StorageCollection<DrawingLocomotive>();
        delLocomotive = new LinkedList<DrawingLocomotive>();
    }
    void comboBoxSelectorCompany_SelectedIndexChanged(String text)
    {
        field.manageBox.setEnabled(false);
    }

    public void insertNewLocomotive(DrawingLocomotive _drawingLocomotive)
    {
        if (_company == null) return;
        if (_company.add(_drawingLocomotive) != -1)
        {
            JOptionPane.showMessageDialog(null, "Объект добавлен");
            field.pictureBox.setIcon(new ImageIcon(_company.show(field.pictureBox)));
        }
        else
        {
            JOptionPane.showMessageDialog(null, "Объект не удалось добавить");
        }
    }
    private void CreateObject(String type)
    {
        if (_company == null) return;
        DrawingLocomotive _drawingLocomotive;
        Random rnd = new Random();
        switch (type)
        {
            case "DrawningLocomotive":
                _drawingLocomotive = new DrawingLocomotive(rnd.nextInt(100, 300),
                        rnd.nextInt(1000, 3000),
                        getColor(rnd));
                break;
            case "DrawningElectricLocomotive":
                _drawingLocomotive = new DrawingElectricLocomotive(rnd.nextInt(100, 300),
                        rnd.nextInt(1000, 3000),
                        getColor(rnd),
                        getColor(rnd),
                        rnd.nextBoolean(),
                        rnd.nextBoolean());
                break;
            default:
                return;
        }
        insertNewLocomotive(_drawingLocomotive);
    }
    private static Color getColor(Random random) {
        Color initialColor = new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256));
        Color selectedColor = JColorChooser.showDialog(null, "Выберите цвет", initialColor);
        if (selectedColor != null) {
            return selectedColor;
        } else {
            return initialColor;
        }
    }

    public void CreateButtonElectricLocomotiveAction(){
        CreateObject("DrawningElectricLocomotive");
    }
    public void CreateButtonLocomotiveAction(){
        CreateObject("DrawningLocomotive");
    }
    public void ButtonCreateSpecialLocomotive_Click()
    {
        FormGenerateLocomotive form = new FormGenerateLocomotive(this);
    }
    public void ButtonRemoveLocomotive_Click(JFormattedTextField maskedTextField)
    {
        if (maskedTextField.getText().isEmpty() || _company == null) return;
        int pos = Integer.parseInt(maskedTextField.getText());
        int choice = JOptionPane.showConfirmDialog(null, "Удалить объект?", "Удаление", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
        if (choice == JOptionPane.NO_OPTION) return;
        DrawingLocomotive obj = _company.remove(_company, pos);


        if (obj != null) {
            delLocomotive.add(obj);
            JOptionPane.showMessageDialog(null, "Объект удален");
            field.pictureBox.setIcon(new ImageIcon(_company.show(field.pictureBox)));
        } else {
            JOptionPane.showMessageDialog(null, "Не удалось удалить объект");
        }
    }
    protected void ButtonGoToCheck_Click()
    {
        if (_company == null) return;
        DrawingLocomotive locomotive = null;
        int counter = 100;
        while (locomotive == null)
        {
            locomotive = _company.GetRandomObjects();
            counter--;
            if(counter <= 0) break;
        }
        if (locomotive == null) return;
        FormElectricLocomotive form = new FormElectricLocomotive(locomotive);

    }
    protected void ButtonRefresh_Click()
    {
        if (_company == null) return;
        field.pictureBox.setIcon(new ImageIcon(_company.show(field.pictureBox)));
    }

    public void ButtonCollectionAdd_Click() {
        if (field.collectionTextBox.getText().isEmpty() || (!field.radioButtonList.isSelected() && !field.radioButtonMassive.isSelected()) || (field.radioButtonList.isSelected() && field.radioButtonMassive.isSelected())) {
            JOptionPane.showMessageDialog(null, "Не все данные заполнены", "Ошибка", JOptionPane.ERROR_MESSAGE);
            return;
        }

        CollectionType collectionType = field.radioButtonList.isSelected() ? CollectionType.List : CollectionType.Massive;
        storageCollection.addCollection(field.collectionTextBox.getText(), collectionType);
        refreshListBoxItems();
    }
    public void ButtonCollectionRemove_Click()
    {
        if (field.listBoxCollection.getSelectedIndex() < 0) {
            JOptionPane.showMessageDialog(null, "Коллекция не выбрана", "Ошибка", JOptionPane.ERROR_MESSAGE);
            return;
        }
        int dialogResult = JOptionPane.showConfirmDialog(null, "Удалить коллекцию?", "Удаление", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
        if (dialogResult == JOptionPane.YES_OPTION) {
            storageCollection.delCollection(field.listBoxCollection.getSelectedValue());
            refreshListBoxItems();
        }
    }
    private void refreshListBoxItems() {
        DefaultListModel<String> listModel = new DefaultListModel<>();
        for (String key : storageCollection.getKeys()) {
            listModel.addElement(key);
        }
        field.listBoxCollection.setModel(listModel);
    }
    public void ButtonCreateCompany_Click() {
        if (field.listBoxCollection.getSelectedIndex() < 0) {
            JOptionPane.showMessageDialog(null, "Коллекция не выбрана", "Ошибка", JOptionPane.ERROR_MESSAGE);
            return;
        }

        ICollectionGenericObjects<DrawingLocomotive> collection = storageCollection.get(field.listBoxCollection.getSelectedValue());
        if (collection == null) {
            JOptionPane.showMessageDialog(null, "Коллекция не проинициализирована", "Ошибка", JOptionPane.ERROR_MESSAGE);
            return;
        }

        switch (field.comboBoxSelectorCompany.getSelectedItem().toString()) {
            case "Хранилище":
                _company = new LocomotiveDepotService(field.pictureBox.getWidth(), field.pictureBox.getHeight(), collection);
                break;
        }
        field.setPanelEnabled(true);
        refreshListBoxItems();
    }
    public void ButtonCheckDel()
    {
        if(delLocomotive.isEmpty()) return;
        FormElectricLocomotive form = new FormElectricLocomotive(delLocomotive.peek());
        delLocomotive.pop();
    }


}

