package ProjectElectricLocomotive.src.Forms;


import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.text.MaskFormatter;
import java.text.ParseException;
public class FormLocomotiveCollection extends JFrame {
    protected int Width;
    private int Height;
    private JPanel storageBox;
    protected JPanel manageBox;
    private JPanel groupBoxTools;
    private JButton buttonAddElectricLocomotive;
    private JButton buttonAddLocomotive;
    protected JComboBox<String> comboBoxSelectorCompany;
    private JButton buttonRefresh;
    private JButton buttonGoToCheck;
    private JButton buttonRemoveLocomotive;
    private JButton buttonCreateSpecialLocomotive;
    private JFormattedTextField maskedTextBoxPosition;

    protected JTextField collectionTextBox;

    protected JLabel pictureBox;
    protected JLabel nameCollection;
    protected JButton buttonAddCollection;
    protected JButton ButtonGoToCheckRemoved;
    protected JList<String> listBoxCollection;
    protected JButton buttonRemoveCollection;
    protected JButton buttonAddCompany;
    protected JRadioButton radioButtonList;
    protected JRadioButton radioButtonMassive;

    DrawingLocomotiveCollection field = new DrawingLocomotiveCollection(this);

    public FormLocomotiveCollection(){
        super("Коллекция локомотивов");
        setSize(900,500);
        Width = getWidth();
        Height = getHeight();
        initComponents();
        RefreshWindow();
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setVisible(true);
    }

    private void initComponents() {
        groupBoxTools = new JPanel();
        storageBox = new JPanel();
        manageBox = new JPanel();
        buttonAddElectricLocomotive = new JButton("Добавление электровоза");
        buttonAddLocomotive = new JButton("Добавление локомотива");
        comboBoxSelectorCompany = new JComboBox<>();
        buttonAddCollection  = new JButton("Добавить коллекцию");
        buttonRefresh = new JButton("Обновить");
        buttonGoToCheck = new JButton("Передать на тесты");
        ButtonGoToCheckRemoved = new JButton("Тест локомотива из удаленных");
        buttonRemoveLocomotive = new JButton("Удалить локомотив");
        buttonCreateSpecialLocomotive = new JButton("Сгенерировать локомотив");
        maskedTextBoxPosition = createMaskedTextField();
        pictureBox = new JLabel();
        nameCollection = new JLabel("Название коллекции");
        collectionTextBox = new JTextField();
        listBoxCollection = new JList<>();
        buttonRemoveCollection = new JButton("Удалить коллекцию");
        radioButtonList = new JRadioButton("Список");
        radioButtonMassive = new JRadioButton("Массив");
        buttonAddCompany = new JButton("Создать компанию");

        comboBoxSelectorCompany.addActionListener(e -> {
            field.comboBoxSelectorCompany_SelectedIndexChanged((String) comboBoxSelectorCompany.getSelectedItem());
        });
        comboBoxSelectorCompany.addItem("");
        comboBoxSelectorCompany.addItem("Хранилище");

        buttonAddLocomotive.addActionListener(e->{
            field.CreateButtonLocomotiveAction();
            repaint();
        });

        buttonAddElectricLocomotive.addActionListener(e->{
            field.CreateButtonElectricLocomotiveAction();
            repaint();
        });
        buttonRemoveLocomotive.addActionListener(e->{
            field.ButtonRemoveLocomotive_Click(maskedTextBoxPosition);
            repaint();
        });
        buttonGoToCheck.addActionListener(e->{
            field.ButtonGoToCheck_Click();
            repaint();
        });
        buttonRefresh.addActionListener(e->{
            field.ButtonRefresh_Click();
            repaint();
        });
        buttonCreateSpecialLocomotive.addActionListener(e->{
            field.ButtonCreateSpecialLocomotive_Click();
            repaint();
        });
        buttonAddCollection.addActionListener(e->
        {
            field.ButtonCollectionAdd_Click();
            repaint();
        });
        buttonRemoveCollection.addActionListener(e->
        {
            field.ButtonCollectionRemove_Click();
            repaint();
        });
        buttonAddCompany.addActionListener(e->
        {
            field.ButtonCreateCompany_Click();
            repaint();
        });
        ButtonGoToCheckRemoved.addActionListener(e->
        {
            field.ButtonCheckDel();
            repaint();
        });

        storageBox.setLayout(new GridLayout(9, 1));
        storageBox.add(nameCollection);
        storageBox.add(radioButtonList);
        storageBox.add(radioButtonMassive);
        storageBox.add(collectionTextBox);
        storageBox.add(buttonAddCollection);
        storageBox.add(listBoxCollection);
        storageBox.add(buttonRemoveCollection);
        storageBox.add(comboBoxSelectorCompany);
        storageBox.add(buttonAddCompany);

        groupBoxTools.setBorder(BorderFactory.createTitledBorder("Инструменты"));
        groupBoxTools.setLayout(new GridLayout(2, 1));

        groupBoxTools.add(storageBox);

        manageBox.setLayout(new GridLayout(8, 1));

        manageBox.add(buttonAddLocomotive);
        manageBox.add(buttonAddElectricLocomotive);
        manageBox.add(maskedTextBoxPosition);
        manageBox.add(buttonRemoveLocomotive);
        manageBox.add(ButtonGoToCheckRemoved);
        manageBox.add(buttonGoToCheck);
        manageBox.add(buttonCreateSpecialLocomotive);
        manageBox.add(buttonRefresh);
        groupBoxTools.add(manageBox);
        setPanelEnabled(false);

        add(groupBoxTools);
        add(pictureBox);
        add(field);

        addComponentListener(new ComponentAdapter() {
            @Override
            public void componentResized(ComponentEvent e) {
                super.componentResized(e);
                Width = getWidth();
                Height = getHeight();
                repaint();
                RefreshWindow();

            }
        });


    }

    public void setPanelEnabled(boolean enabled) {
        for (Component component : manageBox.getComponents()) {
            component.setEnabled(enabled);
        }
    }

    private JFormattedTextField createMaskedTextField() {
        try {
            MaskFormatter formatter = new MaskFormatter("##");
            formatter.setPlaceholderCharacter('_');
            JFormattedTextField maskedTextField = new JFormattedTextField(formatter);
            maskedTextField.setFocusLostBehavior(JFormattedTextField.PERSIST);
            return maskedTextField;
        } catch (ParseException e) {
            e.printStackTrace();
            return new JFormattedTextField();
        }
    }
    public void RefreshWindow(){
        field.setLayout(new FlowLayout());
        groupBoxTools.setBounds(Width - 210, 0, 190, Height - 40);
        pictureBox.setBounds(0,0,Width - 210, Height - 40);
    }
}
