package ProjectElectricLocomotive.src.MovementStrategy;

public class MoveToCenter extends AbstractStrategy
{

    @Override
    protected void moveToTarget() {
        ObjectParameters objParams = getObjectParameters();
        if (objParams == null)
        {
            return;
        }
        int diffX = objParams.getObjectMiddleHorizontal() - fieldWidth / 2;
        if(Math.abs(diffX) > GetStep())
        {
            if (diffX > 0) MoveLeft();
            else MoveRight();
        }
        int diffY = objParams.getObjectMiddleVertical() - fieldHeight / 2;
        if (Math.abs(diffY) > GetStep())
        {
            if (diffY > 0) MoveUp();
            else MoveDown();
        }
    }

    @Override
    protected boolean isTargetDestination() {
        ObjectParameters objParams = getObjectParameters();
        if (objParams == null)
        {
            return false;
        }
        return objParams.getObjectMiddleHorizontal() - GetStep() <= fieldWidth / 2 && objParams.getObjectMiddleHorizontal() + GetStep() >= fieldWidth / 2 &&
                objParams.getObjectMiddleVertical() - GetStep() <= fieldHeight / 2 && objParams.getObjectMiddleVertical() + GetStep() >= fieldHeight / 2;
    }
}
